unit UntPublic;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, StdCtrls, ComCtrls,
  Forms;

const
  HwDevCommDLLName = 'HwDevComm.dll';
  //DeviceInfo( dev_id = "1" dev_type = "HW_HDCP" comm_type = "ip" ip_address = "173.16.6.117" password = "" port_number = "9922")
 // InitDeviceInfo(DevID: string; DevName: string; DevType: string; CommType: string; IPAddr: string;PortNumber: string; Password: string);
  // DevInfoStr       = 'DeviceInfo(dev_id = "%d" dev_type = "HW_HDCP" comm_type = "ip" ip_address = "%s")';
  DevInfoStr       = 'DeviceInfo(dev_id = "%s" dev_type = "%s" comm_type = "%s" ip_address = "%s" port_number = "%s" password = "%s")';
  OperationLogTxt  = 'Log.txt';
  HwDev_Result     = 'result';
  HwDev_Total      = 'total';
  HwDev_Seporator  = '"';
  HwDev_Time       = 'time';
  HwDev_EmployeeID = 'id';
  HwDev_Success    = 'success';
  HwDev_ErrorInfo  = 'Fail to connect the device';
  HwDev_GetEmployee = 'GetEmployee';
  HwDev_DelEmployee = 'DeleteEmployee';
  HDCP_Utils_dllName = 'HDCP_Utils.dll';

type
  TPicType = (
    PIC_OK = 0,     //
    PIC_FAIL,       //
    PIC_CARD        //
  );
  THDCP_Base64Decode = function(input: PChar; var insize: Cardinal): PChar; stdcall;
  THwDev_TotalDone = function(nTotal: Cardinal; nDone: Cardinal): Integer; stdcall;  //callback function, used for progress
  THwDev_ProcessData = function(pDevInfo: PChar; devInfoLen: Cardinal;pRecvBuf: PChar; pRecvLen: Cardinal): Integer; stdcall;  //added by chs

  THwDev_Execute   = function(pDevInfoBuf: PChar;
                              nDevInfoLen: Integer;
                              pSendBuf: PChar;
                              nSendLen: Integer;
                              pRecvBuf: PPChar;
                              pRecvLen: PCardinal;
                              FuncTotalDone: THwDev_TotalDone
                              ): Integer; stdcall;

  THwDev_Server   = function(nSwith: Integer;pServerInfoBuf: PChar;
                            nServerInfoLen: Cardinal;pFuncProcessData:
                            THwDev_ProcessData): Integer; stdcall;   //added by chs
  THwDev_Finish   = procedure(pRecvBuf: PPChar); stdcall;         //cadded by chs


  TDevInfo = packed record
    DevID: string;
    DevType: string;
    IPAddress: string;
    CommType: string;
    PortNumber:string;
    Password:string;
  end;
  PDevInfo = ^TDevInfo;

 procedure CallDevFinishCommDLL(DLLPath: string;
                            pRecvBuf: PPChar);      //HwDev_Finish

 function CallServerCommDLL(DLLPath: string;nSwith: Integer;
                            pServerInfoBuf: PChar;nServerInfoLen: Cardinal;
                            pFuncProcessData: THwDev_ProcessData): Integer;

  function CallHwDevCommDLL(DLLPath: string;
                            pDevInfoBuf: PChar; nDevInfoLen: Integer;
                            pSendBuf: PChar; nSendLen: Integer;
                            pRecvBuf: PPChar; pRecvLen: PCardinal;
                            FuncTotalDone: THwDev_TotalDone): string;

  procedure ShowMess(Mess: string);
  function IsCmdExecSuccess(RltStr: string): Boolean;
  function GetHWDeviceTime(RltStr: string): string;

procedure CallHwDecodeDLL(DLLPath, AFile: string; input: PChar; var insize: Cardinal);
var
  FDLLPath,
  FDevInfoStr,
  PResultStr: string;

implementation

procedure CallDevFinishCommDLL(DLLPath: string;
                            pRecvBuf: PPChar);    //    THwDev_Finish
var
  DLLHandle: THandle;
  CommDLL: THwDev_Finish;
  ret:integer;
begin
  if not FileExists(DLLPath + HwDevCommDLLName) then Exit;
  DLLHandle := LoadLibrary(PChar(DLLPath + HwDevCommDLLName));
  try
    @CommDLL := GetProcAddress(DLLHandle, 'HwDev_Finish');
    if Assigned(@CommDLL) then
    begin
       CommDLL(pRecvBuf);
    end;
  finally
    FreeLibrary(DLLHandle);
  end;
end;

function CallServerCommDLL(DLLPath: string;nSwith: Integer;
    pServerInfoBuf: PChar;nServerInfoLen: Cardinal;pFuncProcessData: THwDev_ProcessData): Integer;
var
  DLLHandle: THandle;
  CommDLL: THwDev_Server;
  ret:integer;
begin
  Result := 0;
  if not FileExists(DLLPath + HwDevCommDLLName) then Exit;
  DLLHandle := LoadLibrary(PChar(DLLPath + HwDevCommDLLName));
  try
    @CommDLL := GetProcAddress(DLLHandle, 'HwDev_Server');
    if Assigned(@CommDLL) then
    begin
       ret :=CommDLL(nSwith, pServerInfoBuf, nServerInfoLen, pFuncProcessData);
    end;
    Result:=ret;
  finally
   // FreeLibrary(DLLHandle);
  end;
end;

function CallHwDevCommDLL(DLLPath: string; pDevInfoBuf: PChar;
  nDevInfoLen: Integer; pSendBuf: PChar; nSendLen: Integer;
  pRecvBuf: PPChar; pRecvLen: PCardinal; FuncTotalDone: THwDev_TotalDone): string;
var
  DLLHandle: THandle;
  CommDLL: THwDev_Execute;
begin
  Result := '';
  if not FileExists(DLLPath + HwDevCommDLLName) then Exit;
  DLLHandle := LoadLibrary(PChar(DLLPath + HwDevCommDLLName));
  try
    @CommDLL := GetProcAddress(DLLHandle, 'HwDev_Execute');
    if Assigned(@CommDLL) then
    begin
      CommDLL(pDevInfoBuf, nDevInfoLen, pSendBuf, nSendLen,
              pRecvBuf, pRecvLen, FuncTotalDone);
      if Assigned(pRecvBuf^) then
        Result := StrPas(pRecvBuf^);
    end;
  finally
    FreeLibrary(DLLHandle);
  end;
end;

procedure CallHwDecodeDLL(DLLPath, AFile: string; input: PChar; var insize: Cardinal);
var
  DLLHandle: THandle;
  CommDLL: THDCP_Base64Decode;
  AImg: PChar;
  ImgData: TMemoryStream;
begin
  if not FileExists(DLLPath + HDCP_Utils_dllName) then Exit;
  DLLHandle := LoadLibrary(PChar(DLLPath + HDCP_Utils_dllName));
  try
    @CommDLL := GetProcAddress(DLLHandle, 'HDCP_Base64Decode');
    if Assigned(@CommDLL) then
    begin
      AImg := CommDLL(input, insize);  //after decoding, convert to PChar
      if AImg <> nil then
      begin
        ImgData := TMemoryStream.Create;
        try
          ImgData.Clear;
          ImgData.Write(AImg^, insize);
          ImgData.Position := 0;
          ImgData.SaveToFile(AFile);
        finally
          ImgData.Free;
        end;
      end;
    end;
  finally
    FreeLibrary(DLLHandle);
  end;
end;

procedure ShowMess(Mess: string);
begin
  Application.MessageBox(PChar(Mess), PChar(Application.Title),
                         MB_OK + MB_ICONINFORMATION);
end;

function IsCmdExecSuccess(RltStr: string): Boolean;
var
  iStartPos: Integer;
  sSucc: string;
begin
  Result := False;
  iStartPos := Pos(HwDev_Result, RltStr);
  if iStartPos = 0 then Exit;
  sSucc := Copy(RltStr, iStartPos + 1, Length(RltStr));
  iStartPos := Pos(HwDev_Seporator, sSucc);
  if iStartPos = 0 then Exit;
  sSucc := Copy(sSucc, iStartPos + 1, Length(sSucc));
  iStartPos := Pos(HwDev_Seporator, sSucc);
  if iStartPos = 0 then Exit;
  sSucc := Copy(sSucc, 0, iStartPos - 1);
  Result := (sSucc = HwDev_Success);
end;

function GetHWDeviceTime(RltStr: string): string;
var
  iStartPos: Integer;
begin
  Result := '';
  iStartPos := Pos(HwDev_Time, RltStr);
  if iStartPos = 0 then Exit;
  Result := Copy(RltStr, iStartPos, Length(RltStr));
  iStartPos := Pos(HwDev_Seporator, Result);
  if iStartPos = 0 then Exit;
  Result := Copy(Result, iStartPos + 1, Length(Result));
  iStartPos := Pos(HwDev_Seporator, Result);
  if iStartPos = 0 then Exit;
  Result := Copy(Result, 0, iStartPos - 1);
end;

end.
